summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Lockywolf2024-03-20 00:49:40 +0100
committer Willy Sudiarto Raharjo2024-03-20 10:33:36 +0100
commit9f74d04686c99f14cec5c1d8dbd96f22ded61163 (patch)
treed50ae645de0a952f796addc85ec0a9523bdcb8c1
parentc3895e2fabba918bdb35503a3a5d7906069df54a (diff)
downloadslackbuilds-9f74d04686c99f14cec5c1d8dbd96f22ded61163.tar.gz
libraries/openimagedenoise: Added (High-Performance Denoising Library).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/openimagedenoise/README36
-rw-r--r--libraries/openimagedenoise/openimagedenoise.SlackBuild121
-rw-r--r--libraries/openimagedenoise/openimagedenoise.info10
-rw-r--r--libraries/openimagedenoise/slack-desc19
4 files changed, 186 insertions, 0 deletions
diff --git a/libraries/openimagedenoise/README b/libraries/openimagedenoise/README
new file mode 100644
index 0000000000..2b1199973f
--- /dev/null
+++ b/libraries/openimagedenoise/README
@@ -0,0 +1,36 @@
+Intel Open Image Denoise
+
+This build does NOT build support for CUDA/Xe/RDNA, patches welcome.
+
+Intel Open Image Denoise is an open source library of high-performance,
+high-quality denoising filters for images rendered with ray tracing.
+Intel Open Image Denoise is part of the IntelĀ® Rendering Toolkit and is
+released under the permissive Apache 2.0 license.
+
+The purpose of Intel Open Image Denoise is to provide an open,
+high-quality, efficient, and easy-to-use denoising library that allows
+one to significantly reduce rendering times in ray tracing based
+rendering applications. It filters out the Monte Carlo noise inherent to
+stochastic ray tracing methods like path tracing, reducing the amount of
+necessary samples per pixel by even multiple orders of magnitude
+(depending on the desired closeness to the ground truth). A simple but
+flexible C/C++ API ensures that the library can be easily integrated
+into most existing or new rendering solutions.
+
+At the heart of the Intel Open Image Denoise library is a collection of
+efficient deep learning based denoising filters, which were trained to
+handle a wide range of samples per pixel (spp), from 1 spp to almost
+fully converged. Thus it is suitable for both preview and final-frame
+rendering. The filters can denoise images either using only the noisy
+color (beauty) buffer, or, to preserve as much detail as possible, can
+optionally utilize auxiliary feature buffers as well (e.g. albedo,
+normal). Such buffers are supported by most renderers as arbitrary
+output variables (AOVs) or can be usually implemented with little
+effort.
+
+Although the library ships with a set of pre-trained filter models, it
+is not mandatory to use these. To optimize a filter for a specific
+renderer, sample count, content type, scene, etc., it is possible to
+train the model using the included training toolkit and user-provided
+image datasets.
+
diff --git a/libraries/openimagedenoise/openimagedenoise.SlackBuild b/libraries/openimagedenoise/openimagedenoise.SlackBuild
new file mode 100644
index 0000000000..b5abac8ae8
--- /dev/null
+++ b/libraries/openimagedenoise/openimagedenoise.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/bash
+
+# Slackware build script for openimagedenoise
+
+# Copyright 2024, Lockywolf
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=openimagedenoise
+VERSION=${VERSION:-2.2.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+TARNAM=oidn
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $TARNAM-$VERSION
+tar xvf $CWD/$TARNAM-$VERSION.src.tar.gz
+cd $TARNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} +
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DCMAKE_CXX_COMPILER_LAUNCHER=ccache \
+ -DCMAKE_C_COMPILER_LAUNCHER=ccache \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ CHANGELOG.md README.md SECURITY.md LICENSE.txt \
+ doc readme.pdf third-party-programs-oneDNN.txt \
+third-party-programs-oneTBB.txt \
+third-party-programs.txt \
+third-party-programs-DPCPP.txt \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mv $PKG/usr/share/doc $PKG/usr/doc/$PRGNAM-$VERSION/built_doc
+rm -rf $PKG/usr/share
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/openimagedenoise/openimagedenoise.info b/libraries/openimagedenoise/openimagedenoise.info
new file mode 100644
index 0000000000..5ee4467e5d
--- /dev/null
+++ b/libraries/openimagedenoise/openimagedenoise.info
@@ -0,0 +1,10 @@
+PRGNAM="openimagedenoise"
+VERSION="2.2.2"
+HOMEPAGE="https://www.openimagedenoise.org/"
+DOWNLOAD="https://github.com/OpenImageDenoise/oidn/releases/download/v2.2.2/oidn-2.2.2.src.tar.gz"
+MD5SUM="40c04b0371334ab863230e99a587fd59"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="ispc"
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.openimagedenoise_2024-03-19@lockywolf.net"
diff --git a/libraries/openimagedenoise/slack-desc b/libraries/openimagedenoise/slack-desc
new file mode 100644
index 0000000000..68058ac61a
--- /dev/null
+++ b/libraries/openimagedenoise/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+openimagedenoise: openimagedenoise (High-Performance Denoising Library for Ray Tracing)
+openimagedenoise:
+openimagedenoise: Intel Open Image Denoise is an open source library of high
+openimagedenoise: performance, high-quality denoising filters for images rendered with
+openimagedenoise: ray tracing. Intel Open Image Denoise is part of the Intel Rendering
+openimagedenoise: Toolkit.
+openimagedenoise:
+openimagedenoise:
+openimagedenoise:
+openimagedenoise:
+openimagedenoise: